/// <reference types="node" />
import { EventEmitter } from "events";
import { ConsoleLogger } from "./services/logger";
import { ConcatMethod } from "../utils/analyse_concat_method";
export declare class DownloadError extends Error {
}
export interface DownloaderOptions {
    videoUrl: string;
    format?: string;
    verbose?: boolean;
    keep?: boolean;
    threads?: number;
    concatMethod?: ConcatMethod;
}
declare class Downloader extends EventEmitter {
    videoUrl: string;
    format: string;
    keepTemporaryFiles: boolean;
    videoChunkUrls: string[];
    audioChunkUrls: string[];
    downloadedVideoChunkFiles: string[];
    downloadedAudioChunkFiles: string[];
    workDirectoryName: string;
    outputFilename: string;
    verbose: boolean;
    logger: ConsoleLogger;
    maxThreads: number;
    concatMethod: ConcatMethod;
    sqStart: number;
    sqEnd: number;
    isLowLatencyLiveStream: boolean;
    isPremiumVideo: boolean;
    isFFmpegAvailable: boolean;
    isFFprobeAvailable: boolean;
    constructor(videoUrl: any, { format, verbose, keep, threads, concatMethod }: Partial<DownloaderOptions>);
    download(): Promise<void>;
}
export default Downloader;
