"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConsoleLogger = void 0;
class Logger {
}
class ConsoleLogger extends Logger {
    constructor() {
        super(...arguments);
        this.debugFlag = false;
    }
    debug(message) {
        if (!this.debugFlag) {
            return;
        }
        console.debug(`${message}`);
    }
    info(message) {
        console.info(`${message}`);
    }
    warning(message) {
        console.warn(`${message}`);
    }
    error(message, error) {
        console.error(`${message}`);
        if (error) {
            console.log(error);
        }
    }
    enableDebug() {
        this.debugFlag = true;
    }
}
exports.ConsoleLogger = ConsoleLogger;
exports.default = new ConsoleLogger();
//# sourceMappingURL=logger.js.map