"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const exec = require("child_process").exec;
const execCommand = (command, silent = false) => {
    return new Promise((resolve, reject) => {
        let child = exec(command);
        child.stdout.on("data", (data) => {
            !silent && console.log(data);
        });
        child.stderr.on("data", (data) => {
            !silent && console.log(data);
        });
        child.on("close", (code, signal) => {
            if (code === 0) {
                resolve();
            }
            else {
                !silent && console.error(code, signal);
                reject();
            }
        });
    });
};
exports.default = execCommand;
//# sourceMappingURL=exec_command.js.map